diff --git a/Documentation/devicetree/bindings/mfd/gateworks-gsc.yaml b/Documentation/devicetree/bindings/mfd/gateworks-gsc.yaml
new file mode 100644
index 00000000..314dc7d
--- /dev/null
+++ b/Documentation/devicetree/bindings/mfd/gateworks-gsc.yaml
@@ -0,0 +1,156 @@
+# SPDX-License-Identifier: GPL-2.0-only OR BSD-2-Clause
+%YAML 1.2
+---
+$id: http://devicetree.org/schemas/mfd/gateworks-gsc.yaml#
+$schema: http://devicetree.org/meta-schemas/core.yaml#
+
+title: Gateworks System Controller multi-function device
+
+description: |
+  The GSC is a Multifunction I2C slave device with the following submodules:
+   - Watchdog Timer
+   - GPIO
+   - Pushbutton controller
+   - Hardware Monitore with ADC's for temperature and voltage rails and
+     fan controller
+
+maintainers:
+  - Tim Harvey <tharvey@gateworks.com>
+  - Robert Jones <rjones@gateworks.com>
+
+properties:
+  $nodename:
+    pattern: "gsc@[0-9a-f]{1,2}"
+  compatible:
+    const: gw,gsc
+
+  reg:
+    description:
+      I2C device address.
+    maxItems: 1
+
+  interrupts:
+    maxItems: 1
+
+  interrupt-controller: true
+
+  "#interrupt-cells":
+    const: 1
+    description:
+      The IRQ number.
+
+  hwmon:
+    description:
+      Optional Hardware Monitoring module.
+
+    properties:
+      compatible:
+        const: "gw,gsc-hwmon"
+
+      "#address-cells":
+        const: 1
+
+      "#size-cells":
+        const: 0
+
+      gw,fan-base:
+        description:
+          The fan controller base address
+
+      patternProperties:
+        "^adc@[0-2]$":
+          type: object
+          description: |
+            Properties for a single ADC which can report cooked values
+            (ie temperature sensor based on thermister), raw values
+            (ie voltage rail with a pre-scaling resistor divider).
+
+          properties:
+            reg:
+              description:
+                Register of the ADC.
+              minimum: 0
+              maximum: 255
+
+           label: true
+             description:
+               Name of the ADC input.
+
+           type:
+             description: |
+               temperature in C*10 (temperature),
+               pre-scaled voltage value (voltage),
+               or scaled based on an optional resistor divider and optional
+               offset (voltage-raw)
+             enum:
+               - temperature
+               - voltage
+               - voltage-raw
+
+           gw,voltage-divider:
+             description: |
+               An array of two integers containing the resistor
+               values R1 and R2 of the optinal resistor divider on a raw ADC.
+
+           gw,voltage-offset:
+             description: |
+               A positive uV voltage offset to apply to a raw ADC
+               (ie to compensate for a diode drop).
+
+           required:
+             - compatible
+             - reg
+             - label
+             - type
+
+    required:
+      - compatible
+
+required:
+  - compatible
+  - reg
+  - interrupts
+  - interrupt-parent
+  - #interrupt-cells
+
+examples:
+  - |
+    i2c {
+        #address-cells = <1>;
+        #size-cells = <0>;
+
+        gsc@20 {
+            compatible = "gw,gsc";
+            reg = <0x20>;
+            interrupt-parent = <&gpio1>;
+            interrupts = <4 GPIO_ACTIVE_LOW>;
+            interrupt-controller;
+            #interrupt-cells = <1>;
+
+            hwmon {
+                compatible = "gw,gsc-hwmon";
+                #address-cells = <1>;
+                #size-cells = <0>;
+                gw,fan-base = <0x2c>;
+
+                adc@0 { /* A0: Board Temperature */
+                    type = "temperature";
+                    reg = <0x00>;
+                    label = "temp";
+                };
+
+                adc@2 { /* A1: Input Voltage (raw ADC) */
+                    type = "voltage-raw";
+                    reg = <0x02>;
+                    label = "vdd_vin";
+                    gw,voltage-divider = <22100 1000>;
+                    gw,voltage-offset = <800000>;
+                };
+
+                adc@b { /* A2: Battery voltage */
+                    type = "voltage";
+                    reg = <0x0b>;
+                    label = "vdd_bat";
+                };
+            };
+        };